﻿using System;
using Microsoft.Crm.Sdk.Messages;
using Microsoft.Xrm.Sdk.Client;

// http://dotnetfollower.com
namespace dotNetFollower
{
    public class CrmUser
    {
        public Guid BusinessUnitId { get; internal set; }
        public Guid OrganizationId { get; internal set; }
        public Guid UserId         { get; internal set; }
    }

    public static class OrganizationServiceProxyExtentions
    {
        public static CrmUser GetCurrentUser(this OrganizationServiceProxy proxy)
        {
            var systemUserResponse = (WhoAmIResponse)proxy.Execute(new WhoAmIRequest());
            return new CrmUser()
            {
                UserId         = systemUserResponse.UserId,
                OrganizationId = systemUserResponse.OrganizationId,
                BusinessUnitId = systemUserResponse.BusinessUnitId
            };
        }
    }
}
